<?php

namespace FiloBlu\Flow\Helper;

use Magento\Catalog\Model\ResourceModel\Category\CollectionFactory;

/**
 * Class CategoryHelper
 * @package FiloBlu\Flow\Helper
 */
class CategoryHelper
{
    /**
     * @var array
     */
    protected $categoryLookup = [];

    /**
     * @var CollectionFactory
     */
    protected $collectionFactory;

    /**
     * CategoryHelper constructor.
     * @param CollectionFactory $collectionFactory
     */
    public function __construct(CollectionFactory $collectionFactory)
    {
        $this->collectionFactory = $collectionFactory;
    }

    /**
     * @return array
     */
    public function getCategoryLookup()
    {
        if (empty($this->categoryLookup)) {
            $collection = $this->collectionFactory->create()
                ->setStore(0)
                ->addNameToResult();

            foreach ($collection as $category) {
                $structure = explode('/', $category->getPath());

                // Removing the category ID 1, I don't need that
                if (($key = array_search('1', $structure, false)) !== false) {
                    unset($structure[$key]);
                }

                if (count($structure) === 0) {
                    continue;
                }

                $leafId = end($structure);
                $this->categoryLookup[$leafId] = $structure;
            }
        }

        return $this->categoryLookup;
    }
}